package com.eactive.eai.agent.transformer;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.transformer.layout.LayoutManager;

public class ReloadLayoutCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadLayoutCommand() {
		super("ReloadLayoutCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			LayoutManager manager = LayoutManager.getManager();

			String layoutName = (String) args;

			if (layoutName != null) {
				if ("ALL".equals(layoutName)) {
					manager.reload();
					manager.permanentReload();
					if (logger.isWarn())
						logger.warn("ReloadLayoutCommand ] all Layout info Reload.");
				} else {
					manager.reload(layoutName);
					manager.permanentReload(layoutName);
					if (logger.isWarn())
						logger.warn("ReloadLayoutCommand ] " + layoutName + " Layout info Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//    public static void main(String[] args)throws Exception{
//        
//        LayoutManager manager = LayoutManager.getManager();
//        
//        Command command = new ReloadLayoutCommand();
//        command.setArgs("");
//        AgentUtil.broadcast(command);
//        
//    }
}
